SystemOrganization addCategory: #'StashShell-NIX'!

StashCommand subclass: #StashNIXBuiltInCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXBuiltInCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	self subclassResponsibility! !

!StashNIXBuiltInCommand classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 15:59'!
new

	^(super new)
		command: self commandString; 
		yourself! !

StashNIXBuiltInCommand subclass: #StashNIXcdCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXcdCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 18:04'!
commandString

	^'cd'! !

!StashNIXcdCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 11:52'!
executeIn: aShell withArgs: argsString
	| args paths |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self missingOperandError ].
	paths := OrderedCollection new.
	self getopts: args into: paths.
	[ 
	aShell path: (aShell resolvePathFromPathString: paths first).
	^ '' ] on: Error do: [ :ex | ^ self command , ': ' , argsString , ': ' , ex messageText ]! !

!StashNIXcdCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 18:05'!
usage

	^'cd [dir]'! !

StashNIXBuiltInCommand subclass: #StashNIXhelpCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXhelpCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'help'! !

!StashNIXhelpCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 10:27'!
executeIn: aShell withArgs: argsString
	| args |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self helpText: aShell ].
	self halt! !

!StashNIXhelpCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 12:34'!
helpText: aShell
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'Smaltalk shell, version ' , ConfigurationOfStashShell project currentVersion versionString;
		cr;
		nextPutAll: 'These shell commands are defined internally.';
		cr;
		nextPutAll: 'Type ''help'' to see this list.';
		cr;
		nextPutAll: 'Type ''help name'' to find out more about the function ''name''.';
		cr;
		nextPutAll: 'Use ''info stash'' to find out more about she shell in general.';
		cr.
	(aShell builtinCommands values asArray sort: [ :a :b | a name <= b name ])
		do: [ :cmd | 
			stream
				cr;
				nextPutAll: cmd usage ].
	^ stream contents! !

!StashNIXhelpCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:42'!
usage

	^'help [functionName]'! !

StashNIXBuiltInCommand subclass: #StashNIXlsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXlsCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'ls'! !

!StashNIXlsCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 12:05'!
executeIn: aShell withArgs: argsString
	| args paths stream first showNodeName pathSize |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ aShell path last listContents ].
	paths := OrderedCollection new.
	self getopts: args into: paths.
	stream := WriteStream on: String new.
	first := true.
	showNodeName := paths size > 1.
	pathSize := paths size.
	1 to: pathSize do: [ :pathIndex | 
		| parentFolder |
		[ 
		parentFolder := (aShell resolvePathFromPathString: (paths at: pathIndex)) last.
		first
			ifFalse: [ stream cr ].
		first := false.
		showNodeName
			ifTrue: [ 
				stream
					nextPutAll: parentFolder name , ':';
					cr ].
		stream nextPutAll: parentFolder listContents.
		pathSize > pathIndex
			ifTrue: [ stream cr ] ]
			on: Error
			do: [ :ex | stream nextPutAll: self command , ': ' , argsString , ': ' , ex messageText ] ].
	^ stream contents! !

!StashNIXlsCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:42'!
usage

	^'ls'! !

StashNIXBuiltInCommand subclass: #StashNIXmkdirCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXmkdirCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'mkdir'! !

!StashNIXmkdirCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 12:50'!
executeIn: aShell withArgs: argsString
	| args childNode paths argCount argIndex stream first |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self missingOperandError ].
	paths := OrderedCollection new.
	self getopts: args into: paths.
	stream := WriteStream on: String new.
	first := true.
	paths
		do: [ :pathString | 
			[ 
			| path parentFolder folder |
			path := [ aShell resolvePathFromPathString: pathString ] on: StashShellNoSuchChild do: [ :ex | ex resume: false ].
			folder := path removeLast.
			parentFolder := path last.
			parentFolder mkdir: folder name ]
				on: Error
				do: [ :ex | 
					first
						ifFalse: [ stream cr ].
					first := false.
					stream nextPutAll: self command , ': ' , argsString , ': ' , ex messageText ] ].
	^ stream contents! !

!StashNIXmkdirCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:57'!
usage

	^'mkdir [OPTION]... DIRECTORY...'! !

StashVirtualMachine subclass: #StashNIXMachine
	instanceVariableNames: 'builtinCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:57'!
builtinCommands
	builtinCommands
		ifNil: [ 
			builtinCommands := Dictionary new.
			StashNIXBuiltInCommand subclasses do: [ :cmdClass | builtinCommands at: cmdClass commandString asSymbol put: cmdClass new ] ].
	^ builtinCommands! !

!StashNIXMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 12:53'!
defaultRoot
	^ (StashNIXDirectory new)
		name: '/';
		yourself! !

!StashDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:37'!
listContents
	^self listContentsWithOptions: #()! !

!StashDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:21'!
listContentsWithOptions: options
	self subclassResponsibility! !

!StashDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:21'!
mkdir: childName

	self subclassResponsibility! !

StashDevice subclass: #StashNIXDirectory
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXDirectory methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:05'!
addChild: aStashChildNode

	aStashChildNode parent: self.
	self children at: aStashChildNode name put: aStashChildNode.! !

!StashNIXDirectory methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:32'!
children

	children ifNil: [ children := Dictionary new ].
	^ children! !

!StashNIXDirectory methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:31'!
children: anObject
	children := anObject! !

!StashNIXDirectory methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:17'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	(options includes: #full)
		ifTrue: [ 
			stream nextPutAll: '.'.
			first := false.
			self parent
				ifNotNil: [ 
					stream
						cr;
						nextPutAll: '..' ] ].
	(self children values asArray sort: [ :a :b | a name <= b name ])
		do: [ :child | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: child name.
			first := false ].
	^ stream contents! !

!StashNIXDirectory methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:20'!
mkdir: childName
	(self hasChildNamed: childName)
		ifTrue: [ self error: 'cannot create directory: ', childName printString , ': File exists' ]
		ifFalse: [ 
			self
				addChild:
					((self class new)
						name: childName;
						yourself) ]! !

!StashShellFolder methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:13'!
listContentsWithOptions: options
	^self object listContentsWithOptions: options! !

!StashShellFolder methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:22'!
mkdir: childName

	^self object mkdir: childName
! !
